/* spu_common.h - Cell-specific includes
 * */

 #ifndef SPU_COMMON_H
 #define SPU_COMMON_H
 
/****************************************************************************
 *  * Global variables
 *   ****************************************************************************/

//Cell BE related declarations -- jtc
#include <errno.h>
#include <libspe2.h>
#include <pthread.h>
#include "encoder/me.h"

//#define SPU_THREADS 8
#define NUM_SPU 8 	// number of spu hardware (used to be SPU_THREADS, but has since been merged)
//------------------Hypervize constants begin here
#define SUCCESS 1
#define FAILURE -1
#define BLOCKING 0
#define NONBLOCKING 1

//Opcode table (just for easier readability
#define OP_HELLO_WORLD 42	//Test function
#define OP_NOP 0	//No operation (idle)
#define OP_INTER_PREDICTION_16x16 1 	//Macroblock analyze

//SPE status codes
#define SPE_IDLE 999
#define SPE_KILL 0
#define BUSY 0
#define IDLE 1
//-----------------Hypervize constants end here
 
#define USE_MUTEX	//Comment this out to disable mutex locking
//#define MUTEX_DEBUG	//Show mutex-related debug messages (lock, unlock success, etc)
//#define HYPERVIZE_DEBUG	//Show hypervize-related debug messages

#define ALIGN16 __attribute__ ((aligned(16)))

#define DECLARE_ALIGNED( var, n ) var __attribute__((aligned(n)))
#define DECLARE_ALIGNED_16( var ) DECLARE_ALIGNED( var, 16 )
#define DECLARE_ALIGNED_8( var )  DECLARE_ALIGNED( var, 8 )
#define DECLARE_ALIGNED_4( var )  DECLARE_ALIGNED( var, 4 )

typedef struct
	{
 	spe_context_ptr_t ctxs;
	//pthread_t threads;
	void *argp;
    void *envp;
	} ppu_pthread_data_t;
    				 					 
//Fire - Smaller structure to hold parameters sent to SPE for encode

typedef struct
{
	int opcode;
	x264_t *h;
	x264_me_t *m;
	int16_t (*mvc)[2];  //DECLARE_ALIGNED_4(int16_t (*mvc)[2]);        //mvc[9][2]
	int i_mvc;
	int *p_halfpel_thresh;
	int spes;
	int parent_thread;
} spu_param_t;
/*
typedef struct //spu_param
	{
	int opcode; //Function number to run on the SPE side
	x264_t *h;
<<<<<<< .mine
	struct x264_mb_analysis_t *a;
=======
	//x264_mb_analysis_t *a;
>>>>>>> .r19
	int run;
	int spes;	//Number of spes
	} spu_param_t;
*/
//Declaring the threads globally
pthread_t threads[NUM_SPU];
ppu_pthread_data_t pthread_data[NUM_SPU];

//Mutex for hypervize
//pthread_mutex_t mutex_lock = PTHREAD_MUTEX_INITIALIZER;

#endif

